//https://docs.oracle.com/javase/tutorial/uiswing/layout/visual.html

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.Random;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;


public class BackPanel extends JPanel {
		int n=10;
		JButton [] buts=new JButton[n*n];
		BufferedImage img;
		BufferedImage [] images;
	public BackPanel() {
		super();
		setLayout(new GridLayout(n,n));
		Random r=new Random();
		int nb=r.nextInt(n);
		takeImage();
		processImage();
		for(int i=0;i<n*n;i++)
		{
			
			JButton b=new JButton();
			buts[i]=b;
			b.setActionCommand("c"+String.valueOf(i));
			CustomAction addAction = new CustomAction(i);
			b.addActionListener(addAction);
			b.setIcon(new ImageIcon(images[i]));
			b.setBackground(Color.white);
			add(b);
			if(nb==i)
			{
				b.setBackground(Color.red);
				b.setActionCommand("red");
				b.setText("");
			}
		}
	}
	public void getImages()
	{
		JButton button = new JButton();
		  try {
			  BufferedImage img = ImageIO.read(getClass().getResource("resources/water.bmp"));
		   // button.setIcon(new ImageIcon(img));
		  } catch (Exception ex) {
		    System.out.println(ex);
		  }
	}
	public void takeImage() 
	{
		URL imgURL = getClass().getResource("/icons01.jpg");
		//System.out.println(imgURL);
		try {
			img=ImageIO.read(imgURL);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void processImage()
	{
		int r=n;
		int c=n;
		int pn=r*c;
		images=new BufferedImage[pn];
		int xorg=10;
		int yorg=10;
		int iNum=0;
		int w=60,h=60;
		for(int j=0;j<r;j++)
		{
			for(int i=0;i<c;i++)
			{
				images[iNum]=new BufferedImage(w,h, BufferedImage.TYPE_INT_RGB);
				int x1=xorg+60*i;
				int y1=yorg+60*j;
				images[iNum]=img.getSubimage(x1,y1,w,h);	
				iNum++;
			}
		}
	}
	
	private class CustomAction implements ActionListener
	{
	  private int id;
	 
	  public CustomAction(int id)
	  {
	      this.id = id;
	  }
	 
	  public void actionPerformed(ActionEvent event)
	  {
		  JButton target=(JButton) event.getSource();
	      System.out.println(event.getActionCommand()+" "+id+" "+target.getBounds());
	      target.setIcon(new ImageIcon(images[4]));
	      
	      if(target.getBackground()==Color.red)
	      {
	    	  target.setBackground(Color.blue);
	      }else
	      {
	    	  target.setBackground(Color.red);
	      }
	      
	  }
	}
}